clear; clc; close all;

load RiskMeasures
load EPU_Historical

VaR_p95 = double(VaR_p95);
VaR_p99 = double(VaR_p99);
return_loss = double(return_loss);

Observed = ~isnan(VaR_p95(2:end, 2:end));

VaR95 = VaR_p95(2:end, 2:end); % First column belongs to the market
VaR99 = VaR_p99(2:end, 2:end); 

Ret = return_loss(2:end, 2:end);

CondVar = Historical_EPU(2:end, 2);

m_vector = 1:10;
bootstrp_n = 1000;

results_VaR95 = NaN(length(m_vector), size(VaR95, 2));
results_VaR99 = NaN(length(m_vector), size(VaR95, 2));
for ind_firm = 1:size(VaR95, 2)
    for m = m_vector
            
            Observed_tmp = Observed(:, ind_firm);
            Moment_VaR95 = (Ret(Observed_tmp, ind_firm)  <= VaR95(Observed_tmp, ind_firm)) - 0.95;
            Moment_VaR99 = (Ret(Observed_tmp, ind_firm)  <= VaR99(Observed_tmp, ind_firm)) - 0.99;
          
            CondVar_tmp = CondVar(Observed_tmp); 
            results = Specification_Test_Bootstrap(Moment_VaR95, CondVar_tmp, m, bootstrp_n);
            results_VaR95(m, ind_firm) = results.decision;
       
            results = Specification_Test_Bootstrap(Moment_VaR99, CondVar_tmp, m, bootstrp_n);
            results_VaR99(m, ind_firm) = results.decision;
         
    end
        
end
clearvars -except results_*
save OUTPUT_VaR


