clear; clc; close all;

load RiskMeasures
load CoVaR_term
load EPU_Historical

return_loss = double(return_loss);

Observed = ~isnan(CoVaR95);

Ret = return_loss(2:end, 2:end); % First column is the market loss
Ret_Sys = return_loss(2:end, 1);

CondVar = Historical_EPU(2:end, 2);

m_vector = 1:10;
bootstrp_n = 1000;

results_CoVaR95 = NaN(length(m_vector), size(CoVaR95, 2));
results_CoVaR99 = NaN(length(m_vector), size(CoVaR95, 2));
for ind_firm = 1:size(CoVaR95, 2)  
    for m = m_vector

            Observed_tmp = Observed(:, ind_firm);

            Moment_CoVaR95 = (Ret_Sys(Observed_tmp)  <= CoVaR95(Observed_tmp, ind_firm)) - 0.95;
            Moment_CoVaR99 = (Ret_Sys(Observed_tmp)  <= CoVaR99(Observed_tmp, ind_firm)) - 0.99;

            CondVar_tmp = CondVar(Observed_tmp); 

            results = Specification_Test_Bootstrap(Moment_CoVaR95, CondVar_tmp, m, bootstrp_n);
            results_CoVaR95(m, ind_firm) = results.decision;
            
            results = Specification_Test_Bootstrap(Moment_CoVaR99, CondVar_tmp, m, bootstrp_n);            
            results_CoVaR99(m, ind_firm) = results.decision;

    end
    
end
clearvars -except results_*

save OUTPUT_CoVaR_term
